//
//  sample.m

#import "sample.h"
#import "Constants.h"

@interface sample (private)
- (void)openNFOFile:(NSString *)aPath;
- (void)updateWithNFOInfo:(NSString *)xmlString to:(id)aDVD withPath:(NSString *)aPath;
@end

@implementation sample


#pragma mark Init
+ (id)plugin;
{ 
    return [[[self alloc] init] autorelease];
}


- (id)init {
	if (self = [super init]) {
		/*
		NSMenuItem *aMenuItem = [[[NSMenuItem alloc] init] autorelease];
		[aMenuItem setTitle:@"A Test Menu"];
		[aMenuItem setTarget:self];
		[aMenuItem setAction:@selector(doTest:)];
		
		NSMenuItem *secondMenuItem = [[[NSMenuItem alloc] init] autorelease];
		[secondMenuItem setTitle:@"A Second Menu"];
		[secondMenuItem setTarget:self];
		[secondMenuItem setAction:@selector(doSecondTest:)];

		
		 MyPluginManager *pluginManager = [[NSApp delegate] pluginManager];
		[pluginManager addMenuItem:aMenuItem];
		[pluginManager addMenuItem:secondMenuItem];
		[pluginManager addMenuItem:[NSMenuItem separatorItem]];
		 */
		
				
	}
	return self;
}


- (void)dealloc {
	[super dealloc];
}


#pragma mark -
#pragma mark Menu Command

/*
- (IBAction)doTest:(id)sender {
	NSLog(@"Doing a Test");
}
- (IBAction)doSecondTest:(id)sender {
	NSLog(@"Doing another Test");
}
 */


- (NSArray *)menuCommandFor:(NSArray *)selectedObjects {

	MyCollectionTableView *collections = [[NSApp delegate] getCollections];
	mainLibrary = [[collections libraryCollection] valueForKey:@"entries"]; //This is your main library, set now for use in the openNFOFile: method 
	
	// Go through the directory and only open files that are NFO
	MyWarningSheet *warningSheet = [[NSApp delegate] sharedWarningSheet];
	[warningSheet showProgressSheetWithTitle:@"Updating..." subtitle:@"" count:0];
	
	NSString *parentPath = @"/Volumes/MyDirve/Movies"; //Set to your movies path or ask for it with an NSOpenPanel
 	
	NSDirectoryEnumerator *dirEnum = [[NSFileManager defaultManager] enumeratorAtPath:parentPath];
	NSString *nextFile;
	while (nextFile = [dirEnum nextObject]) {
		[warningSheet setSubtitleForProgress:nextFile];
		NSString *extension = [nextFile pathExtension];

		if ([extension isEqualToString:@"nfo"]) {
			NSString *fullPathToNFO = [parentPath stringByAppendingPathComponent:nextFile];
				[self openNFOFile:fullPathToNFO];
			}	
	}
	
	[warningSheet closeProgressSheet];
	return nil;
}
	

- (void)openNFOFile:(NSString *)aPath {
	
	
	NSError *anError = nil; 
	NSString *xmlString = [NSString stringWithContentsOfFile:aPath usedEncoding:nil error:&anError];
	if (xmlString == nil) {
		NSLog(@"Error opening .nfo file: %@\n%@", aPath, anError);
		return;
	}
	
	
	//Assume they all have the IMDb ID to make a perfect match
	NSString *imdbID = [xmlString stringBetween:@"<id>" and:@"</id>"];
	if ([imdbID hasPrefix:@"tt"])
		imdbID =[imdbID substringFromIndex:2];
	
	if (imdbID) {
		//Search library for a match, library is a NSSet that can be filtered 
		NSPredicate *filterPredicate = [NSPredicate predicateWithFormat:@"imdb == %@", imdbID];
		NSSet *filterResult = [mainLibrary filteredSetUsingPredicate:filterPredicate]; //10.5 only function
		
		NSUInteger count = [filterResult count]; 
		if (count == 1) {
			NSManagedObject *aDVD = [filterResult anyObject];
			//Update 
			NSLog(@"Updating: %@", [aDVD valueForKey:@"title"]);
			[self updateWithNFOInfo:xmlString to:aDVD withPath:aPath];
		}
		else if (count == 0) {
			//Add new
			NSMutableDictionary *aMovieDictionary = [NSMutableDictionary dictionary];
			[self updateWithNFOInfo:xmlString to:aMovieDictionary withPath:aPath];
			NSLog(@"Adding new: %@", aMovieDictionary);

			[[NSApp delegate] addEntriesWithAttributes:[NSArray arrayWithObject:aMovieDictionary]];
		}
		else {
			NSLog(@"Found more than one match?");
		}
		
	}
}
	

- (void)updateWithNFOInfo:(NSString *)xmlString to:(id)aDVD withPath:(NSString *)aPath {
		
	// aDVD might be an NSManagedObject or NSMutableDictionary, but they botgh respond to the same Key Value Coding functions
	
	//Given an NFO and aDVD we update or fill in all the details 
	
	NSString *parentFolder = [aPath stringByDeletingLastPathComponent];
		
	NSString *title = [[xmlString stringBetween:@"<title>" and:@"</title>"] stringByCleaningHTML];
	NSString *year = [xmlString stringBetween:@"<year>" and:@"</year>"];
	NSDate *yearDate = nil;
	if (year) {
		NSDateFormatter *yearDateFormatter = [[[NSDateFormatter alloc] init] autorelease];
		[yearDateFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];
		[yearDateFormatter setDateFormat:@"yyyy"];		
		yearDate = [yearDateFormatter dateFromString:year];
	}
	
	NSString *premiered = [xmlString stringBetween:@"<premiered>" and:@"</premiered>"];
	if (premiered) {
		NSDateFormatter *dateReaderFormatter = [[[NSDateFormatter alloc] init] autorelease];
		[dateReaderFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];
		[dateReaderFormatter setDateFormat:@"yyyy-MM-dd"];
		yearDate = [dateReaderFormatter dateFromString:premiered];
	}
	
	NSString *episodedetails = [xmlString stringBetween:@"<episodedetails>" and:@"</episodedetails>"];
	
	NSString *episodeName = [[episodedetails stringBetween:@"<title>" and:@"</title>"] stringByCleaningHTML];
	[aDVD setValue:episodeName forKey:@"custom1"]; //Just a smaple, might not be custom1 field that you want

	
	
	// All attributes are updated without checking if the already exist
	[aDVD setValue:title forKey:@"title"];
	[aDVD setValue:yearDate forKey:@"theatrical"];
	
	
	NSString *tempString = [xmlString stringBetween:@"<originaltitle>" and:@"</originaltitle>"];
	if (tempString)
		[aDVD setValue:[tempString stringByCleaningHTML] forKey:@"originalTitle"];
	
	tempString = [xmlString stringBetween:@"<rating>" and:@"</rating>"];
	NSString *votes = [xmlString stringBetween:@"<votes>" and:@"</votes>"];
	if (tempString && votes) {
		if ([tempString length] > 3)
			tempString = [tempString substringToIndex:3];
		
		tempString = [NSString stringWithFormat: @"%@ (%@ votes)", tempString, votes];
		
		[aDVD setValue:tempString forKey:@"rating"];
	}
	
	tempString = [xmlString stringBetween:@"<tagline>" and:@"</tagline>"];
	if (tempString)
		[aDVD setValue:[tempString stringByCleaningHTML] forKey:@"comments"];
	
	tempString = [xmlString stringBetween:@"<runtime>" and:@"</runtime>"];
	if (tempString)
		[aDVD setValue:tempString forKey:@"duration"];
	
	tempString = [xmlString stringBetween:@"<mpaa>" and:@"</mpaa>"];
	if (tempString)
		[aDVD setValue:[tempString stringByCleaningHTML] forKey:@"rated"];
	
	tempString = [xmlString stringBetween:@"<id>" and:@"</id>"];
	if (tempString && [tempString hasPrefix:@"tt"])
		[aDVD setValue:[tempString substringFromIndex:2]  forKey:@"imdb"];
	
	tempString = [xmlString stringBetween:@"<plot>" and:@"</plot>"];
	if (tempString)
		[aDVD setValue:[tempString stringByCleaningHTML] forKey:@"summary"];
	
	tempString = [xmlString stringBetween:@"<genre>" and:@"</genre>"];
	if (tempString) {
		NSMutableString *changeSlash = [NSMutableString stringWithString:tempString];
		[changeSlash replaceOccurrencesOfString:@" / " withString:@", " options:NSLiteralSearch range:NSMakeRange(0, [changeSlash length])];
		[aDVD setValue:[changeSlash stringByCleaningHTML] forKey:@"genre"];
	}
	
	tempString = [xmlString stringBetween:@"<director>" and:@"</director>"];
	if (tempString)
		[aDVD setValue:[tempString stringByCleaningHTML] forKey:@"director"];
	
	tempString = [xmlString stringBetween:@"<studio>" and:@"</studio>"];
	if (tempString)
		[aDVD setValue:[tempString stringByCleaningHTML] forKey:@"studio"];
	
	
	
	tempString = [episodedetails stringBetween:@"<episode>" and:@"</episode>"];
	if (tempString) {
			[aDVD setValue:tempString forKey:@"custom2"];
	}
	
	tempString = [episodedetails stringBetween:@"<season>" and:@"</season>"];
	if (tempString) {
			[aDVD setValue:tempString forKey:@"custom3"];
	}
	
	premiered = [episodedetails stringBetween:@"<aired>" and:@"</aired>"];
	if (premiered) {
		NSDateFormatter *dateReaderFormatter = [[[NSDateFormatter alloc] init] autorelease];
		[dateReaderFormatter setFormatterBehavior:NSDateFormatterBehavior10_4];
		[dateReaderFormatter setDateFormat:@"yyyy-MM-dd"];
		NSDate *premieredDate = [dateReaderFormatter dateFromString:premiered];
		[aDVD setValue:premieredDate forKey:@"releaseDate"];
	}
	

	
	// <thumb>http://ia.ec.imdb.com/media/imdb/01/I/25/65/31/10f.jpg</thumb>  there could be one for each actor
	
	// All the folloing links are added without checking if they already exist
	// Use link set and check against the URLs before adding
	//NSMutableSet *linksSet = [aDVD mutableSetValueForKey:@"linksSet"];
	
	NSString *movieFile = [xmlString stringBetween:@"<filename>" and:@"</filename>"];
	// <filenameandpath>c:\Dummy_Movie_Files\Movies\...So Goes The Nation.avi</filenameandpath>
	// <filename>27 Dresses.avi</filename>
	
	if (movieFile) {
		NSString *fullPath = [parentFolder stringByAppendingPathComponent:movieFile];
		
		if ([[NSFileManager defaultManager] fileExistsAtPath:fullPath]) {
			NSDictionary *aLink = [NSDictionary dictionaryWithObjectsAndKeys:title, @"name", fullPath, @"url", @"Movie", @"type", nil];
			[aDVD addLinkWithAttributtes:aLink];
					
		}
	}
	
	NSString *filenameandpath = [xmlString stringBetween:@"<filenameandpath>" and:@"</filenameandpath>"];
	if (filenameandpath && [filenameandpath hasPrefix:@"file://"]) {
		
		if ([[NSFileManager defaultManager] fileExistsAtPath:filenameandpath]) {
			NSDictionary *aLink = [NSDictionary dictionaryWithObjectsAndKeys:title, @"name", filenameandpath, @"url", @"Movie", @"type", nil];
			[aDVD addLinkWithAttributtes:aLink];
			
		}
	}
	 
	
	NSString *episodeGuideURL = [xmlString stringBetween:@"<episodeguideurl>" and:@"</episodeguideurl>"];
	if (episodeGuideURL) {	
		NSDictionary *aLink = [NSDictionary dictionaryWithObjectsAndKeys:@"Episode Guide", @"name", episodeGuideURL, @"url", @"Episode Guide", @"type", nil];
		[aDVD addLinkWithAttributtes:aLink];

	}
	
	NSString *trailerURL = [xmlString stringBetween:@"<trailer>" and:@"</trailer>"];
	if (trailerURL) {
		NSDictionary *aLink = [NSDictionary dictionaryWithObjectsAndKeys:@"Trailer", @"name", trailerURL, @"url", @"Trailer", @"type", nil];
		[aDVD addLinkWithAttributtes:aLink];
	}
	
	
	// Import thumb nail from same folder and link to fan art
	
	NSString *nameOfFile = [[aPath lastPathComponent] stringByDeletingPathExtension];
	NSString *coverPath = [parentFolder stringByAppendingFormat:@"/%@.tbn", nameOfFile];
	// 	NSString *coverPath = [parentFolder stringByAppendingFormat:@"/%@.tbn", title];
	
	if (![[NSFileManager defaultManager] fileExistsAtPath:coverPath]) {	
		coverPath = nil;
		NSDirectoryEnumerator *dirEnum = [[NSFileManager defaultManager] enumeratorAtPath:parentFolder];
		NSString *nextFile;
		
		while (nextFile = [dirEnum nextObject]) {
			if ([[nextFile pathExtension] isEqualToString: @"tbn"]) {
				coverPath = [parentFolder stringByAppendingPathComponent:nextFile];
				break;
			}
		}
	}
	
	if (coverPath) {
		//NSString *dataFolderPath = [appController dataFolderPath];
		NSImage *newImage = [[NSImage alloc] initWithContentsOfFile:coverPath];
		[aDVD setCoverImage:newImage];
		[newImage release];	
		
	}

	return;
}


@end
